// Next.js API route support: https://nextjs.org/docs/api-routes/introduction
import type {NextApiRequest, NextApiResponse} from "next";
import {app} from "@/firebase";
import {getFirestore, getDoc, doc, deleteDoc, setDoc} from "firebase/firestore";
import {withIronSessionApiRoute} from "iron-session/next";
import {sessionOptions} from "@/lib/session";
import {Ticket, TicketTypeLabel, TicketStatusLabel} from "@/interfaces/ticket";
import moment from "moment";
import {sendEmail} from "@/email";

const db = getFirestore(app);

export default withIronSessionApiRoute(handler, sessionOptions);

async function handler(req: NextApiRequest, res: NextApiResponse) {
	if (req.method === "GET") return await get(req, res);
	if (req.method === "DELETE") return await del(req, res);
	if (req.method === "PATCH") return await patch(req, res);

	res.status(404).json(undefined);
}

async function get(req: NextApiRequest, res: NextApiResponse) {
	if (!req.session.user) {
		res.status(401).json({ok: false});
		return;
	}

	const {id} = req.query as {id: string};

	const snapshot = await getDoc(doc(db, "tickets", id));

	if (snapshot.exists()) {
		res.status(200).json({...snapshot.data(), id: snapshot.id});
	} else {
		res.status(404).json(undefined);
	}
}

async function del(req: NextApiRequest, res: NextApiResponse) {
	if (!req.session.user) {
		res.status(401).json({ok: false});
		return;
	}

	const {id} = req.query as {id: string};

	const snapshot = await getDoc(doc(db, "tickets", id));
	const data = snapshot.data() as Ticket;

	const user = req.session.user;
	if (user.type === "admin" || user.type === "developer") {
		await deleteDoc(snapshot.ref);
		res.status(200).json({ok: true});
		return;
	}

	res.status(403).json({ok: false});
}

async function patch(req: NextApiRequest, res: NextApiResponse) {
	if (!req.session.user) {
		res.status(401).json({ok: false});
		return;
	}

	const {id} = req.query as {id: string};
	const body = req.body as Ticket;

	const snapshot = await getDoc(doc(db, "tickets", id));

	const user = req.session.user;
	if (user.type === "admin" || user.type === "developer") {
		const data = snapshot.data() as Ticket;
		await setDoc(snapshot.ref, body, {merge: true});
		try {
			// send email if the status actually changed to completed
			if (data.status !== req.body.status && req.body.status === "completed") {
				await sendEmail(
					"ticketStatusCompleted",
					{
						id,
						subject: body.subject,
						reporter: body.reporter,
						date: moment(body.date).format("DD/MM/YYYY - HH:mm"),
						type: TicketTypeLabel[body.type],
						reportedFrom: body.reportedFrom,
						description: body.description,
						environment: process.env.ENVIRONMENT,
					},
					[data.reporter.email],
					`Ticket ${id}: ${data.subject}`,
				);
			}
		} catch (err) {
			console.error(err);
			// doesnt matter if the email fails
		}
		res.status(200).json({ok: true});
		return;
	}

	res.status(403).json({ok: false});
}
